local myFont = dxCreateFont ( "font.ttf",12 )
local altx,alty,altz
local gefahreneKM = 0
local screenWidth, screenHeight = guiGetScreenSize()
local speedWidth, speedHeight = 350, 50 -- размеры спидометра
local hudColor = tocolor ( 191, 184, 168 ) -- цвет спидометра
local oneThingSize = (speedHeight)/3
local speedHeight = oneThingSize*3+10
local posX, posY = screenWidth-speedWidth, screenHeight/2+screenHeight/4
local lastTick = getTickCount()
local driveDistance

addEventHandler("onClientPlayerVehicleEnter",getRootElement(),function(veh,seat)
	if source == localPlayer then
		altx, alty, altz=getElementPosition(veh)
		lastTick = getTickCount()
		driveDistance = getElementData ( veh, "driveDistance" )
		--outputChatBox ("distance on enter "..tostring(driveDistance).." "..tostring(getElementData ( veh, "driveDistance" )))
	end
end
)

function showSpeedometer()
	local veh = getPedOccupiedVehicle(getLocalPlayer()) 
	if not veh or getVehicleOccupant ( veh ) ~= localPlayer then return true end
	if not driveDistance then lastTick = getTickCount() driveDistance = getElementData ( veh, "driveDistance" ) or 0 end
	dxDrawRectangle ( posX, posY, speedWidth, speedHeight, tocolor (0,0,0,50) )
	dxDrawText("Скорость: "..tostring ( getElementSpeed ( veh ) ).." КМ/Ч", posX+10, posY+5, posX+speedWidth, posY+speedHeight,hudColor,1,myFont)
	dxDrawText("Бензин: "..tostring ( math.round(getElementData ( veh, "fuel" ) or 0 )).." л", posX+10, posY+5+oneThingSize, posX+speedWidth, posY+speedHeight,hudColor,1,myFont)
	dxDrawText("Пробег: "..tostring ( math.round(driveDistance),1).." км", posX+10, posY+5+oneThingSize*2, posX+speedWidth, posY+speedHeight,hudColor,1,myFont)
	--dxDrawText("Пробег: "..tostring ( driveDistance).." км", posX+10, posY+5+oneThingSize*2, posX+speedWidth, posY+speedHeight,hudColor,1,myFont)
	
	local neux, neuy, neuz = getElementPosition(veh)
	if not altx or not alty or not altz then
		altx, alty, altz=getElementPosition(veh)
	end
	local driveTotal = getDistanceBetweenPoints3D(neux,neuy,neuz,altx,alty,altz)
	driveTotal = driveTotal/1000
	altx,alty,altz=neux,neuy,neuz
	driveDistance = math.round(driveDistance+driveTotal,3)
	if lastTick+5000 < getTickCount() then
		lastTick = getTickCount()
		setElementData ( veh, "driveDistance", driveDistance )
	end
		--gefahreneKM=gefahreneKM+DriveDistance
	--altx,alty,altz=neux,neuy,neuz
end


addEventHandler("onClientRender",getRootElement(),showSpeedometer)	

addEventHandler("onClientPlayerVehicleExit", localPlayer,
	function (vehicle, seat)
		if seat == 0 then
			setElementData ( vehicle, "driveDistance", driveDistance )
			driveDistance = nil
		end
	end)
	
addEventHandler("onClientPlayerWasted",getLocalPlayer(),function ()
	local veh = getPedOccupiedVehicle(getLocalPlayer()) 
	if not veh and getVehicleOccupant ( veh ) ~= localPlayer then return true end
	setElementData ( source, "driveDistance", driveDistance )
	driveDistance = nil
end)
	
function getElementSpeed(element)
	speedx, speedy, speedz = getElementVelocity (element)
	actualspeed = (speedx^2 + speedy^2 + speedz^2)^(0.5) 
	kmh = actualspeed * 180
	return math.round(kmh)
end

function math.round(number, decimals, method)
    decimals = decimals or 0
    local factor = 10 ^ decimals
    if (method == "ceil" or method == "floor") then return math[method](number * factor) / factor
    else return tonumber(("%."..decimals.."f"):format(number)) end
end

